/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-oauth1-settings-document.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {PolymerElement} from '@polymer/polymer/polymer-element.js';

import {html} from '@polymer/polymer/lib/utils/html-tag.js';

import {AmfHelperMixin} from '@api-components/amf-helper-mixin/amf-helper-mixin.js';

declare namespace ApiElements {

  /**
   * `api-oauth1-settings-document`
   *
   * Documentation view for AMF OAuth2 security settings.
   *
   * Settings can be passed by setting the `settings` property to AMF's
   * settings property of Security Scheme.
   *
   * ```html
   * <api-oauth1-settings-document
   *  amf-model="{...}"
   *  settings="{...}"></api-oauth1-settings-document>
   * ```
   *
   * It is also possible to set corresponding properties directly.
   *
   * ```html
   * <api-oauth1-settings-document
   *  amf-model="{...}"
   *  request-token-uri="https://..."
   *  authorization-uri="https://..."
   *  signatures='["RSA-SHA1"]'></api-oauth1-settings-document>
   * ```
   *
   * ## Styling
   *
   * `<api-oauth1-settings-document>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-oauth1-settings-document` | Mixin applied to this elment | `{}`
   */
  class ApiOauth1SettingsDocument extends
    AmfHelperMixin(
    Object) {

    /**
     * OAuth1 settings scheme of AMF.
     * When this property changes it resets other properties.
     */
    settings: object|null;

    /**
     * The request token URI from the settings model.
     * Automatically set when `settings` property change.
     */
    requestTokenUri: string|null|undefined;

    /**
     * Computed value. True if `requestTokenUri` is set.
     */
    readonly hasRequestTokenUri: boolean|null|undefined;

    /**
     * The authorization endpoint URI.
     * Automatically set when `settings` property change.
     */
    authorizationUri: string|null|undefined;

    /**
     * Computed value. True if `authorizationUri` is set.
     */
    readonly hasAuthorizationUri: boolean|null|undefined;

    /**
     * Token credentials endpoint URI.
     * Automatically set when `settings` property change.
     */
    tokenCredentialsUri: string|null|undefined;

    /**
     * Computed value. True if `tokenCredentialsUri` is set.
     */
    readonly hasTokenCredentialsUri: boolean|null|undefined;

    /**
     * List of signatures used by this authorization server.
     * Automatically set when `settings` property change.
     */
    signatures: Array<String|null>|null;

    /**
     * Computed value. True if `signatures` is set.
     */
    readonly hasSignatures: boolean|null|undefined;

    /**
     * Called automatically when `settings` property change (whole object,
     * not sub property).
     * Sets values of all other properties to the one found in the AMF.
     *
     * @param settings AMF settings to process.
     */
    _settingsChanged(settings: object|null): void;

    /**
     * If passed argument is an array it returns first object from it. Otherwise
     * it returns the object.
     */
    _deArray(result: any|null): any|null;

    /**
     * Computes value of request token endpoint URI.
     *
     * @param settings AMF settings to process.
     * @returns Request token URI value
     */
    _computeRequestTokenUri(settings: object|null): String|null|undefined;

    /**
     * Computes value of authorization endpoint URI.
     *
     * @param settings AMF settings to process.
     * @returns Authorization URI value
     */
    _computeAuthorizationUri(settings: object|null): String|null|undefined;

    /**
     * Computes value of token credentials endpoint URI.
     *
     * @param settings AMF settings to process.
     * @returns Token credentials URI value
     */
    _computeTokenCredentialsUri(settings: object|null): String|null|undefined;

    /**
     * Computes value of OAuth1 signatures.
     *
     * @param settings AMF settings to process.
     * @returns List of signatures.
     */
    _computeSignatures(settings: object|null): Array<String|null>|null|undefined;
  }
}

declare global {

  interface HTMLElementTagNameMap {
    "api-oauth1-settings-document": ApiElements.ApiOauth1SettingsDocument;
  }
}
